package jsystem;

import javax.microedition.lcdui.*;
import kjava.awt.Frame;
import kjava.awt.Color;
import kjava.awt.Event;

import java.util.*;


public class JDesktop extends Canvas{
        private Vector frames = new Vector(); // windows
        int focus = -1; // window which has focus
        Image cup=null, buts=null,butn=null,butx=null,menu=null;
        boolean move = false, maxmin = false;
		
		public boolean showmenu = false;
		String menuitem[] = { "Open","Close","Exit" };
		int menuWidth, menuHeight, menuitemheight, menuselect=-1;
		
        int xn, yn, wn, hn, mmode, oldx, oldy;
        final int MOVE = 0, LEFT_RESIZE = 1, RIGHT_RESIZE = 2,
                  TOP_RESIZE = 3, BOTTOM_RESIZE = 4, B_R_RESIZE = 5,
                  B_L_RESIZE = 6, T_R_RESIZE=7, T_L_RESIZE=8,
                  BUT_1=9, BUT_2=10, BUT_3=11, CLIENT=12;
				  

        Image offImage = null;
        int cb = Color.color(0,128,128),
            c0 = Color.color(0,0,128),
            c1 = Color.color(223,223,223),
            c2 = Color.color(255,255,255),
            c3 = Color.color(192,192,192),
            c4 = Color.color(128,128,128),
            c5 = Color.color(0,0,0);        

        public JDesktop(){
            try{
               cup     = Image.createImage("/icons/cp.png");
               buts    = Image.createImage("/icons/buts.png");
               butn    = Image.createImage("/icons/butn.png");
               butx    = Image.createImage("/icons/butx.png");
               menu    = Image.createImage("/icons/menu.png");
            }catch(Exception e){
               System.out.println("Could not load Images.");
            }
			// Determine size of menu
			javax.microedition.lcdui.Font f = 
                javax.microedition.lcdui.Font.getDefaultFont();
			menuWidth = 0;
			for(int i=0; i< menuitem.length; i++){
				int l = f.stringWidth(menuitem[i]);
				if(l > menuWidth)
				menuWidth = l;
			}
			menuWidth += 5;
			menuitemheight = f.getHeight();
			menuHeight = menuitem.length * menuitemheight + 4;

       }

     public void addFrame(Frame frame){
            if(focus>=0)
                ((Frame)frames.elementAt(focus)).hasFocus = false;
            frames.addElement(frame);
            focus = frames.size()-1;
            if(focus>=0)
                ((Frame)frames.elementAt(focus)).hasFocus = true;
            repaint();
     }

     public void removeFrame(){
          if(focus>=0)
               frames.removeElementAt(focus);
          focus = frames.size()-1;
          if(focus>=0)
                ((Frame)frames.elementAt(focus)).hasFocus = true;
          repaint();
     }
	 
	 public Object getFocus(){
	 	if( focus < 0 )
			return null;
		if( ((Frame)frames.elementAt(focus)).mode == Frame.MINIMIZED )
			return null;
		return frames.elementAt(focus);
	}

     static final int DX = 8, DY = 18+8+1;

	public void paint(Graphics g){
		if( focus<0 ){
			g.setColor(cb);
			g.fillRect(0,0, getWidth(), getHeight());
			g.drawImage(menu,getWidth(),getHeight(),g.RIGHT|g.BOTTOM);
			if(showmenu){
				drawMenu( g );
			}
			return;
		}
		// Resize frames to desktop	
		// Required since Palm Java does not know height
		// at create time
		for(int i=0; i<frames.size(); i++){
			Frame f = (Frame)frames.elementAt(i);
			if( f.mode == Frame.MAXIMIZED){
				f.width = getWidth();
            	f.height= getHeight()-19;
			}
		}
		Image off = offImage;
		
		if(off == null){
			try{
				off  = Image.createImage(getWidth(), getHeight());
				drawDesktop(off.getGraphics());
				g.drawImage(off,0,0,g.LEFT|g.TOP);
				offImage = off;
				return;
			}catch(Exception ex){
			}catch(Error er){
			}
		}
		if(off == null){
			JSystem.showConsole();
			JSystem.out.println("Not enough memory to show desktop.");
			return;
		}
		
		if(move){ 
			g.drawImage(off,0,0,g.LEFT|g.TOP);
            g.setColor(Color.lightGray);
            g.drawRect(xn,yn,wn+DX,hn+DY);
			g.drawImage(menu,getWidth(),getHeight(),g.RIGHT|g.BOTTOM);
		}else if(showmenu){
			g.drawImage(off,0,0,g.LEFT|g.TOP);
			drawMenu( g );
/*        }else if (((Frame)frames.elementAt(focus)).mode      == Frame.MAXIMIZED &&
				  ((Frame)frames.elementAt(focus)).paintmode == Frame.UPDATE)
			Frame f = (Frame)frames.elementAt(focus);
			g.drawImage(off,0,0,g.LEFT|g.TOP);
         	g.translate(f.X+4, f.Y+18+4+1);
         	g.setClip(0,0,f.width,f.height);
			f.paint(g);*/
		}else{
			drawDesktop(off.getGraphics());
			g.drawImage(off,0,0,g.LEFT|g.TOP);
		}
    }
	
	int getMenuselect(int x,int y){
		if(x > getWidth()-menuWidth-20 && x < getWidth()-20){
			int s = (y - (getHeight()-menuHeight+2)) / menuitemheight;
			if( s >= 0 && s < menuitem.length )
				return s;
		}
		return -1;
	}

	
	void drawMenu( javax.microedition.lcdui.Graphics g){
		g.setColor(200,200,200);
		g.fillRect(getWidth()-menuWidth-20, getHeight()-menuHeight, 
					menuWidth, menuHeight);
		if( menuselect >= 0 ){
			g.setColor(150,150,255);
			g.fillRect(getWidth()-menuWidth-20, 
					getHeight()-menuHeight+2+menuitemheight*menuselect, 
					menuWidth, menuitemheight);
		}
		g.setColor(0,0,0);
		g.drawRect(getWidth()-menuWidth-20, getHeight()-menuHeight, 
					menuWidth, menuHeight);
		for(int i=0; i< menuitem.length; i++){
			g.drawString(menuitem[i], getWidth()-menuWidth-17,
					getHeight()-menuHeight+2+menuitemheight*i, 
					g.LEFT|g.TOP);
		}
	}

			
		
	 
	void drawDesktop( javax.microedition.lcdui.Graphics g){
		g.setColor(cb);
		g.fillRect(0,0, getWidth(), getHeight());
		if(((Frame)frames.elementAt(focus)).mode != Frame.MAXIMIZED){
			for(int i=0; i<frames.size(); i++){
				if(i!=focus)
					drawFrame((Frame)frames.elementAt(i), g);
 			}
		}
		drawFrame((Frame)frames.elementAt(focus), g);
		g.drawImage(menu,getWidth(),getHeight(),g.RIGHT|g.BOTTOM);
	}
	 

     void drawFrame(Frame f, javax.microedition.lcdui.Graphics g){
         // Total size of window   
         int width = f.width+DX, height = f.height+DY;
		 
         // paint window frame
         g.setColor(c1);
         g.drawLine(f.X, f.Y, f.X+width-1, f.Y);
         g.drawLine(f.X, f.Y, f.X, f.Y+height-1);
         g.setColor(c5);
         g.drawLine(f.X+width-1, f.Y, f.X+width-1, f.Y+height-1);
         g.drawLine(f.X, f.Y+height-1, f.X+width-1, f.Y+height-1);

         g.setColor(c2);
         g.drawLine(f.X+1, f.Y+1, f.X+width-2, f.Y+1);
         g.drawLine(f.X+1, f.Y+1, f.X+1, f.Y+height-2);
         g.setColor(c4);
         g.drawLine(f.X+width-2, f.Y+1, f.X+width-2, f.Y+height-2);
         g.drawLine(f.X+1, f.Y+height-2, f.X+width-2, f.Y+height-2);
            
         g.setColor(c3);
         g.fillRect(f.X+2, f.Y+2, width-4, height-4);

         if(!f.hasFocus)
             g.setColor(c4);
         else
             g.setColor(c0);
         g.fillRect(f.X+4, f.Y+4, width-8, 18);
            
         if(cup!=null)
                 g.drawImage(cup,f.X+4, f.Y+4, g.TOP|g.LEFT);
         Image b=null;
         switch(f.mode){
               case Frame.NORMAL:    b=butn; break;
               case Frame.MAXIMIZED: b=butx; break;
               case Frame.MINIMIZED: b=buts; break;
         }
         g.setColor(c2);
         g.fillRect(f.X+4, f.Y+4+18+1, f.width, f.height);
            
         if(b!=null)
               g.drawImage(b,f.X+width-52-4, f.Y+4, g.TOP|g.LEFT);

         // Write title
         // g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_MEDIUM));
         if(!f.hasFocus)
             g.setColor(Color.black);
         else
             g.setColor(Color.white);

         g.setClip(f.X,f.Y,f.width-50, 30);
         g.drawString(f.title, f.X+4+20, f.Y+2, g.TOP|g.LEFT);

         g.setColor(c5);  
         g.translate(f.X+4, f.Y+18+4+1);
         g.setClip(0,0,f.width,f.height);
         if(f.mode != Frame.MINIMIZED){
                f.paint(g);  
                //frame.paintComponents(g);
         }
         g.translate(-(f.X+4), -(f.Y+18+4+1));
         g.setClip(0,0,getWidth(), getHeight());
    }


	public void perform( String command ){
		if( command.equals("Open") ){
			if(JSystem.browser != null){
           		JSystem.browser.updateDirlist();
				JSystem.display.setCurrent(JSystem.browser);
			}
		}else if( command.equals("Close")){
			removeFrame();
        	repaint();
		}else if(command.equals("Exit")){
			JSystem.showConsole();
		}
	}
  

		public void pointerDragged(int x, int y){
			if(showmenu) return;
            if(focus<0) return;
            Frame frame = (Frame)frames.elementAt(focus);
            if( move ){
                switch(mmode){
                 case MOVE:  
                      xn = frame.X + x - oldx;
                      yn = frame.Y + y - oldy;
                      break;
                 case LEFT_RESIZE:
                      xn = frame.X + x - oldx;
                      wn = frame.width + oldx - x;
                      break;                            
                 case RIGHT_RESIZE:
                      wn = frame.width + x - oldx;
                      break;
                 case TOP_RESIZE:
                      yn = frame.Y + y - oldy;
                      hn = frame.height+ oldy - y;
                      break;
                 case BOTTOM_RESIZE:
                      hn = frame.height+ y - oldy;
                      break;
                 case B_R_RESIZE:
                      wn = frame.width + x - oldx;
                      hn = frame.height+ y - oldy;
                      break;
                 case T_R_RESIZE:
                      yn = frame.Y + y - oldy;
                      hn = frame.height+ oldy - y;
                      wn = frame.width + x - oldx;
                      break;
                 case B_L_RESIZE:
                      hn = frame.height+ y - oldy;
                      xn = frame.X + x - oldx;
                      wn = frame.width + oldx - x;
                      break;
                case T_L_RESIZE:
                      xn = frame.X + x - oldx;
                      wn = frame.width + oldx - x;
                      yn = frame.Y + y - oldy;
                      hn = frame.height+ oldy - y;
                      break;
             }
             repaint();
          }else{
		  		Event e = frame.getMoveEvent(x-frame.X-4,y-frame.Y-18-4-1);
            	if(e!=null)
                	frame.handleEvent(e);
		  }		  		
        }
 
        public void pointerReleased(int x,int y){
			// Menu
			if(showmenu){
				int s = getMenuselect(x,y);
				if( s >= 0 ){
					if( s == menuselect ){
						perform( menuitem[s] );
						menuselect = -1;
						showmenu = false;
					}else{
						menuselect = -1;
					}
				}else{
					menuselect = -1;
					showmenu = false;
				}
				repaint();
				return;
			}
						
				
			if(!move){
				if(x>=getWidth()-16 && y >= getHeight()-16){
					menuselect = -1;
					showmenu = true;
					repaint();
					return;
				}
			}
			
            if(focus<0) return;
            Frame frame = (Frame)frames.elementAt(focus);
			
            if( move ){
                frame.X = xn;
                frame.Y = yn;
                frame.width = wn;
                frame.height= hn;
                move = false;
                repaint();
            }else{
			 	Event e = frame.getReleaseEvent(x-frame.X-4,y-frame.Y-18-4-1);
            	if(e!=null)
                	frame.handleEvent(e);
                return;
            }
        }


        public void pointerPressed(int x, int y){
			if(showmenu) {			
				int s = getMenuselect(x,y);
				if( s != menuselect ){
					menuselect = s;
					repaint();
				}
				return;
			}
            if(focus<0) return;
            Frame frame = (Frame)frames.elementAt(focus);
            Event e = frame.getClickEvent(x-frame.X-4,y-frame.Y-18-4-1);
            if(e!=null){
                frame.handleEvent(e);
                return;
            }
            switch( mmode = getControl(x,y) ){
                case MOVE: 
                case LEFT_RESIZE:
                case RIGHT_RESIZE:
                case TOP_RESIZE:
                case BOTTOM_RESIZE:
                case B_R_RESIZE:
                case T_R_RESIZE:
                case B_L_RESIZE:
                case T_L_RESIZE:
                     oldx = x; oldy = y;
                     xn = frame.X;
                     yn = frame.Y;
                     wn = frame.width;
                     hn = frame.height;
                     move = true;
                     repaint();
                     return;
                 case BUT_1:
                     switch(frame.mode){
                        case Frame.NORMAL:
                           frame.minimize(true);
                           break;
                        case Frame.MAXIMIZED:
                           frame.minimize(false);
                           break;
                        case Frame.MINIMIZED:
                           frame.restore();
                           break;
                     }
                     return;
                 case BUT_2:
                     switch(frame.mode){
                        case Frame.NORMAL:
                            frame.maximize(true);
                            break;
                        case Frame.MAXIMIZED:
                            frame.restore();
                            break;
                        case Frame.MINIMIZED:
                            frame.maximize(false);
                            break;
                     }
                     return;
                 case BUT_3:
                     e = new Event();
                     e.id = Event.WINDOW_DESTROY;
                     frame.handleEvent(e);
                     return;
				}

             if(inFrame(x,y,frame)) return;

             // Check other windows
             for(int i=frames.size()-1; i>=0; i--){
                 if(i!=focus){
                    Frame f = (Frame)frames.elementAt(i);
                    if( inFrame(x,y,f) ){
                         frame.hasFocus = false;
                         f.hasFocus = true;
                         focus = i;
                         repaint();
                         return;
                    }
                 }
             }
                         
        }
	
      
      public void setTaskleiste(){
          int x=0, y=getHeight()-23;    
          for(int i=0; i<frames.size(); i++){
              Frame f = (Frame)frames.elementAt(i);
              if(f.mode == Frame.MINIMIZED){
                  f.X = x; x+= f.getWidth()+DX;
              }
          }
      }

        boolean inFrame(int x, int y, Frame f){
           return x >= f.X && x < f.X+f.width+DX &&
                y >= f.Y && y < f.Y+f.height+DY;
        } 

        int getControl(int x, int y){
            if(focus<0) return -1;
            Frame frame = (Frame)frames.elementAt(focus);
            // In Frame ?
            int width = frame.width + DX, height = frame.height + DY;
            if( x >= frame.X && x < frame.X+width &&
                y >= frame.Y && y < frame.Y+height ){
                // In client area ?
                x-=frame.X; y-=frame.Y;
                if(x>=4 && x<width-4 &&y>=4+18+1 && y<height-4){
                    return CLIENT;
                }else{
                    // Check Control buttons
                    int xb =x-(width-52-4), yb =y-4;
                    if(xb>=0 && xb<16 && yb>=2 && yb<16)
                        return BUT_1;
                    if(xb>=16 && xb<32 && yb>=2 && yb<16)
                        return BUT_2;
                    if(xb>=34 && xb<50 && yb>=2 && yb<16)
                        return BUT_3;
                    // Suppress resize events for max/min Windows
                    if(frame.mode != Frame.NORMAL)
                        return -1;
                    if(x<10 && y<10)
                        return T_L_RESIZE;
                    if(x<10 && y>height-10)
                        return B_L_RESIZE;
                    if(x>width-10 && y>height-10)
                        return B_R_RESIZE;
                    if(x>width-10 && y<10)
                        return T_R_RESIZE;

                    if(x<4)
                         return LEFT_RESIZE;
                    if(x>=width-4)
                         return RIGHT_RESIZE;
                    if(y<4)
                         return TOP_RESIZE;
                    if(y>=height-4)
                         return BOTTOM_RESIZE;
                    if(y<=18+4+1)
                         return MOVE;
                }
            }
            return -1;
      }

	public void keyPressed(int keyCode){
		// Process nongameaction codes.
		// Used for Desktop interaction
		// without pointer
        Event e;
		Frame frame;
		switch(keyCode){
			case Canvas.KEY_NUM0: // Cycle through windows
				if(focus>=0 && frames.size()>1){
					int fneu = (focus==0?frames.size()-1:focus-1);
					Frame f = (Frame)frames.elementAt(focus);
					f.hasFocus = false;
					f = (Frame)frames.elementAt(fneu);
					f.hasFocus = true;
					focus=fneu;
					repaint();
					return;
				}
				return;
			case Canvas.KEY_NUM1: // Toggle Menu
				if(showmenu){
					menuselect=-1;
					showmenu = false;
				}else{
					menuselect = 0;
					showmenu = true;
				}
				repaint();
				return;
			case Canvas.KEY_NUM3: // Toggle windows size
            	if(focus<0) return;
            	frame = (Frame)frames.elementAt(focus);
           		switch(frame.mode){
          			case Frame.NORMAL:
                      	frame.maximize(true);
						break;
					case Frame.MAXIMIZED:
                      	frame.minimize(false);
                        break;
                    case Frame.MINIMIZED:
                      	frame.restore();
                        break;
              	}
                return;
			case Canvas.KEY_NUM7: // Move window right
            	if(focus<0) return;
            	frame = (Frame)frames.elementAt(focus);
				if(frame.mode == Frame.NORMAL){
					int xneu = frame.X + 10;
					if(xneu > getWidth()-10)
						xneu = 10 - frame.width;
					frame.X = xneu;
					repaint();
				}
				return;
			case Canvas.KEY_NUM9: // Move window down
            	if(focus<0) return;
            	frame = (Frame)frames.elementAt(focus);
				if(frame.mode == Frame.NORMAL){
					int yneu = frame.Y + 10;
					if(yneu > getHeight()-10)
						yneu = 10 - frame.height;
					frame.Y = yneu;
					repaint();
				}
				return;
			case Canvas.KEY_STAR: // Increase window size
            	if(focus<0) return;
            	frame = (Frame)frames.elementAt(focus);
				if(frame.mode == Frame.NORMAL){
					frame.width += 10;
					frame.height += 10;
					repaint();
              	}
                return;
			case Canvas.KEY_POUND: // Decrease window size
            	if(focus<0) return;
            	frame = (Frame)frames.elementAt(focus);
				if(frame.mode == Frame.NORMAL){
					int wneu = frame.width - 10;
					if(wneu < 50)
						wneu = 50;
					int hneu = frame.height - 10;
					if(hneu < 40)
						hneu = 40;						
					frame.width = wneu;
					frame.height =hneu;
					repaint();
              	}
                return;
			case Canvas.KEY_NUM2:  // Send keys 2,4,5,6,8 to application
			case Canvas.KEY_NUM4:
			case Canvas.KEY_NUM5:
			case Canvas.KEY_NUM6:
			case Canvas.KEY_NUM8:
            	if(focus<0) return;
            	frame = (Frame)frames.elementAt(focus);
            	   e = new Event();
                   e.id = Event.KEY_ACTION;
                   e.key = keyCode;
                   frame.handleEvent(e);   
                   return;				   
		}
		
		if(showmenu){
			int gameaction = 0;
          	try{
              gameaction = getGameAction(keyCode);
          	}catch(Exception e2){
              return;
          	}	
          	switch(gameaction){
               case Canvas.UP:
			   		int m = menuselect -1;
					if(m<0)
						m = menuitem.length-1;
					menuselect = m;
					repaint();
					return; 
               case Canvas.DOWN  :
			   		m = menuselect +1;
					if(m>=menuitem.length)
						m = 0;
					menuselect = m;
					repaint();
					return; 
               case Canvas.FIRE  :
			   		if( menuselect >= 0 ){
						perform( menuitem[menuselect] );
						menuselect = -1;
						showmenu = false;
						repaint();
					}
					return;
         	}
			return;
		}
				

 		if(focus<0) return;
		frame = (Frame)frames.elementAt(focus);
          int gameaction = 0;
          try{
              gameaction = getGameAction(keyCode);
          }catch(Exception e3){
              return;
          }
          switch(gameaction){
               case Canvas.RIGHT:
                   e = new Event();
                   e.id = Event.KEY_ACTION;
                   e.key = Event.RIGHT;
                   frame.handleEvent(e);   
                   break;
               case Canvas.LEFT  :
                   e = new Event();
                   e.id = Event.KEY_ACTION;
                   e.key = Event.LEFT;
                   frame.handleEvent(e);   
                   break;
               case Canvas.UP:
                   e = new Event();
                   e.id = Event.KEY_ACTION;
                   e.key = Event.UP;
                   frame.handleEvent(e);   
                   break;
               case Canvas.DOWN  :
                   e = new Event();
                   e.id = Event.KEY_ACTION;
                   e.key = Event.DOWN;
                   frame.handleEvent(e);   
                   break;
               case Canvas.FIRE  :
                   e = new Event();
                   e.id = Event.KEY_ACTION;
                   e.key = Event.ENTER;
                   frame.handleEvent(e);   
                   break;
         }
      }
	  
	  	public void keyReleased(int keyCode){
			if(showmenu) return;
			 		if(focus<0) return;
			Frame frame = (Frame)frames.elementAt(focus);
          	int gameaction = 0;
          	try{
              gameaction = getGameAction(keyCode);
          	}catch(Exception e){
              return;
          	}
          	Event e;
          	switch(gameaction){
               case Canvas.RIGHT:
                   e = new Event();
                   e.id = Event.KEY_ACTION_RELEASE;
                   e.key = Event.RIGHT;
                   frame.handleEvent(e);   
                   break;
               case Canvas.LEFT  :
                   e = new Event();
                   e.id = Event.KEY_ACTION_RELEASE;
                   e.key = Event.LEFT;
                   frame.handleEvent(e);   
                   break;
               case Canvas.UP:
                   e = new Event();
                   e.id = Event.KEY_ACTION_RELEASE;
                   e.key = Event.UP;
                   frame.handleEvent(e);   
                   break;
               case Canvas.DOWN  :
                   e = new Event();
                   e.id = Event.KEY_ACTION_RELEASE;
                   e.key = Event.DOWN;
                   frame.handleEvent(e);   
                   break;
               case Canvas.FIRE  :
                   e = new Event();
                   e.id = Event.KEY_ACTION_RELEASE;
                   e.key = Event.ENTER;
                   frame.handleEvent(e);   
                   break;
         }
      }


   }
