package jsystem;

import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

// Some extensions to the standard System class

public class JSystem{

    public static Display display;        
    public static JConsole console = null;
    public static JDesktop desktop = null;
	public static FileBrowser browser = null;
	public static Vfs vfs = null;
    public static String ls = System.getProperty("line.separator");  

    public static void showConsole() { 
		display.setCurrent(console) ; 
		if(desktop != null)
			desktop.offImage = null;
	}
    
	public static void showDesktop() { 
		if(desktop != null)
			display.setCurrent(desktop) ; 
	}

	public static void initDesktop(Display display){
		JSystem.display = display;	

        // Initialize Desktop
        desktop = new JDesktop();

		// Set the line separator character
        // This should be a system property but isn't
        try{
           ByteArrayOutputStream b = new ByteArrayOutputStream();
           PrintStream p = new PrintStream(b);
           p.println();
           p.close();
           b.close();
           ls = b.toString();
        }catch(Exception e){
        }
		
		// Initialize Virtual File System
		try{
			vfs = new Vfs("JSystem");
		}catch(Exception e){
		}
	}

	public static void initConsole(Display display) {
		JSystem.display = display;	

       // Initialize shell
        console=new JConsole();
		out = console.stdout;  
        err = console.stdout;  
        in  = console.stdin;
		
		// Set the line separator character
        // This should be a system property but isn't
        try{
           ByteArrayOutputStream b = new ByteArrayOutputStream();
           PrintStream p = new PrintStream(b);
           p.println();
           p.close();
           b.close();
           ls = b.toString();
        }catch(Exception e){
        }
		
		// Initialize Virtual File System
		try{
			vfs = new Vfs("JSystem");
		}catch(Exception e){
		}
	}

	public static void init(Display display) {
		JSystem.display = display;	

        // Initialize Desktop
        desktop = new JDesktop();

       // Initialize shell
        console=new JConsole();
		out = console.stdout;  
        err = console.stdout;  
        in  = console.stdin;
		
		// Set the line separator character
        // This should be a system property but isn't
        try{
           ByteArrayOutputStream b = new ByteArrayOutputStream();
           PrintStream p = new PrintStream(b);
           p.println();
           p.close();
           b.close();
           ls = b.toString();
        }catch(Exception e){
        }
		
		// Initialize Virtual File System
		try{
			vfs = new Vfs("JSystem");
		}catch(Exception e){
		}
	}

    public static  InputStream in;
    public static  PrintStream out;
    public static  PrintStream err;


	public static void err( String message ){
		display.setCurrent(new Alert("Alert",
					  		message,null,null),
							display.getCurrent());
		try{
			Thread.sleep(1000);
		}catch(Exception e){
		}
	}



    public static void exit(int status){
       desktop.removeFrame();
   }
   

	public static Hashtable cloneHashtable(Hashtable h){
		Hashtable nh = new Hashtable();
		Enumeration e = h.elements();
		Enumeration k = h.keys();
     	while(k.hasMoreElements()){
             nh.put(k.nextElement(), e.nextElement());
     	}
     	return nh;
  	}

	public static Vector cloneVector(Vector v){
		Vector nv = new Vector();
		Enumeration e = v.elements();
     	while(e.hasMoreElements()){
             nv.addElement(e.nextElement());
     	}
     	return nv;
  	}



}

