package kjava.io;

import java.io.*;

public class BufferedInputStream extends InputStream{
    private InputStream is;
    private byte[] buf = new byte[1024];
    private int pos = 0,mark = 0,bav = 0;


    public BufferedInputStream(InputStream is){
         this.is = is;
    }
 
    public synchronized void mark(int readlimit){
         // Enough bytes in buffer?
         if(pos + readlimit >= bav){
             for(int i=pos; i<bav; i++)
                 buf[i-pos]=buf[i];
             try{
                bav = is.read(buf, bav-pos, buf.length-(bav-pos)) + (bav-pos);
             }catch(Exception e){}
             pos = 0;
         }
         mark = pos;
    } 

    public synchronized void reset(){
         pos = mark;
    }

    public int read()  throws IOException{
        if(pos>=bav){
             bav = is.read(buf, 0, buf.length);
             pos = 0;
        }
        if(pos>=bav){
             return -1;
        }
        return (int)buf[pos++];
    }

    public void close()
           throws IOException{
        is.close();
    }
}
        

